import { Table } from '../../core/table';
import { User } from '../../core/user';
import { GuestBook } from '../../guest-book/guest-book';

import { Kot } from './kot';
import { VoucherType } from './voucher-type';

export class Bill {
  id: string | undefined;
  date: string;
  pax: number;
  customer?: { id: string; name: string };
  user: User;
  creationDate: string;
  lastEditDate: string;
  billId: string;
  kotId: string;
  table: Table;
  guest: GuestBook;
  // settlements: any[];
  voidReason: string;
  voucherType: VoucherType;
  serial: number;
  kots: Kot[];
  // reprints: any[];

  get dateTip(): string {
    return this.date;
  }

  get creationDateTip(): string {
    return this.date;
  }

  get lastEditDateTip(): string {
    return this.date;
  }

  public constructor(init?: Partial<Bill>) {
    this.id = undefined;
    this.date = '';
    this.pax = 0;
    this.user = new User();
    this.creationDate = '';
    this.lastEditDate = '';
    this.billId = '';
    this.kotId = '';
    this.table = new Table();
    this.guest = new GuestBook();
    // this.settlements = [];
    this.voidReason = '';
    this.voucherType = VoucherType.Kot;
    this.serial = 0;
    this.kots = [];
    // this.reprints = [];
    Object.assign(this, init);
  }
}
